enyo.kind({
	name: "AddedPrinter",
	kind: enyo.Item,
	tapHighlight: false,
	className: "AddedPrinterItem enyo-item",
	published: {
		printerID: "",
		printerName: "",
		printerAddress: "",
		printerSSID: ""
	},
	events: {
		onRemove: ""
	},
	components: [
		{kind: "PrintManagerService", components: [
			{name: "removePrinter", method: "printers/delete", onSuccess: "removePrinterSuccess", onFailure: "removePrinterFailure"}
		]},
		{kind: "HFlexBox", align: "center", pack: "justify", components: [
			{kind: "VFlexBox", className: "info", flex: 1, components: [
				{content: "", name: "printerNameLabel", className: "name"},
				{content: "", name: "printerAddressLabel", className: "address"}
			]},
			{kind: "Button", name: "removeButton", className: "enyo-button-negative remove", caption: $L("Remove"), onclick: "removeClick"}
		]},
		{kind: "Popup", name: "removeConfirmPopup", scrim: true, modal: true, width: "351px", height: "auto", components: [
			{name: "removeConfirmMessage", content: $L("Remove manually added printer?"), flex: 1, className: "message"},
			{kind: "HFlexBox", pack: "justify", components: [
				{kind: "Button", flex: 1, caption: $L("Yes"), style:"margin-right:15px", onclick: "removeConfirmYesClick",},
				{kind: "Button", flex: 1, caption: $L("No"), onclick: "removeConfirmNoClick",}
			]}
		]},
		{kind: "MessageBox", name: "messageBox"}
	],
	create: function() {
		this.inherited(arguments);
		this.printerNameChanged();
		this.printerAddressChanged();

		console.log("AddedPrinter create: printerID = " + this.getPrinterID());
		console.log("AddedPrinter create: printerSSID = " + this.getPrinterSSID());
	},
	printerNameChanged: function() {
		this.$.printerNameLabel.setContent(this.getPrinterName());
	},
	printerAddressChanged: function() {
		this.$.printerAddressLabel.setContent(this.getPrinterAddress());
	},
	removeClick: function() {
		console.log("AddedPrinter removeClick: printerSSID = " + this.printerSSID);
		this.$.removeConfirmPopup.openAtCenter();
	},
	removeConfirmYesClick: function() {
		console.log("AddedPrinter removeConfirmYesClick");
		this.$.removeConfirmPopup.close();
		this.$.removeButton.setDisabled(true);
		this.$.removePrinter.call({printerID: this.printerID, ssid: this.printerSSID});
	},
	removeConfirmNoClick: function() {
		console.log("AddedPrinter removeConfirmNoClick");
		this.$.removeConfirmPopup.close();
	},
	removePrinterSuccess: function(inSender, inResponse, inRequest) {
		console.log("AddedPrinter removePrinterSuccess: " + JSON.stringify(inResponse));
		console.log("AddedPrinter create: printerID = " + this.getPrinterID());
		this.doRemove(this.getPrinterID(), this.getPrinterName(), this.getPrinterAddress(), this.getPrinterSSID());
	},
	removePrinterFailure: function(inSender, inResponse, inRequest) {
		console.log("AddedPrinter removePrinterFailure: " + JSON.stringify(inResponse));
		console.log(inSender.getName() + " FAIL: " + inResponse.errorText);
		this.$.removeButton.setDisabled(false);
		this.$.messageBox.showMessage(PrintManagerError.getErrorText(inResponse.errorCode));
	}
});
