enyo.kind({
	name: "enyo.Canon.PrintQueue",
	kind: enyo.VFlexBox,
	currentWifiSsid: "",
	ssidList: [],
	addedPrinterList: [],
	autoPrinters: [],
	removeComponentData: {},
	components: [
		{kind: "PrintManagerService", onFailure: "printManagerFailure", components: [
			{name: "getRenderStatus", method: "jobs/getRenderStatus", subscribe: true, onSuccess: "renderStatusSuccess"},
			{name: "getStatus", method: "jobs/getStatus", subscribe: true, onSuccess: "jobStatusSuccess"},
			{name: "addPrinter", method: "printers/add", onSuccess: "addPrinterSuccess", onFailure: "addPrinterFailure"},
			{name: "listAddedPrinters", method: "printers/listAddedPrinters", onSuccess: "listAddedPrintersSuccess", onFailure: "listAddedPrintersFailure"},
			{name: "findPrinters", method: "printers/list", subscribe: true, onSuccess: "findPrintersSuccess"}
		]},
		{kind: "PalmService", name: "connectionStatus", service: "palm://com.palm.connectionmanager/",
			method: "getstatus", params: {}, onSuccess: "connectionStatusSuccess", onFailure: "connectionStatusFailure"},
		{kind: "PalmService", name: "helpLauncher", service: "palm://com.palm.applicationManager/", method: "open"},
		{kind: "Toolbar", className: "header enyo-toolbar-light", pack: "center", components: [
			{kind: "Image", src: "images/app_icon.png", className: "icon"},
			{kind: "Control", content: $L("Printing")}
		]},
		{className:"header-shadow"},
		{kind: "Pane", name: "bodyPane", height: "100%", transitionKind: "enyo.transitions.Simple", components: [
			{kind: "BasicScroller", name: "queuePane", height: "100%", components: [
				{kind: "VFlexBox", align: "center", pack: "justify", width: "100%", components: [
					{kind: "VFlexBox", className:"container enyo-preferences-box", height: "100%", components: [
						{kind: "Button", name: "addRemovePrinterButton", className: "enyo-button-light", caption: $L("Add  or remove printer"), onclick: "addRemovePrinterClick", disabled: false},
						{kind: "RowGroup", className: "queue", caption: $L("Print Queue"), name: "jobList", components: [
							{kind: "Item", name: "jobListErrorMessageItem", className: "JobStatusItem enyo-item", components: [
								{content: $L("Currently there are no jobs in the printing queue."), name: "jobListErrorMessage", className: "message"}
							]}
						]},
						{kind: "Button", name: "cancelAllButton", className: "enyo-button-negative", caption: $L("Cancel all"), onclick: "cancelAllClick", disabled: true}
					]},
				]}
			]},
			{kind: "BasicScroller", className: "manage", name: "printerPane", height: "100%", showing: false, components: [
				{kind: "VFlexBox", align: "center", pack: "justify", flex:1, width: "100%", components: [
					{kind: "VFlexBox", height: "100%", className:"container printers enyo-preferences-box", components: [
							{kind: "VFlexBox", className: "new", components: [
							{content: $L("To add a printer, enter the IP address and give it a name.")},
							{kind: "RowGroup", components: [
								{kind: "Input", name: "newPrinterID", hint: $L("Enter Printer IP address"), value: "", oninput: "printerIDInput"}
							]},
							{kind: "RowGroup", components: [
								{kind: "Input", name: "newPrinterName", hint: $L("Name Printer"), value: ""}
							]}
						]},
						{kind: "Button", name: "addPrinterButton", className: "enyo-button-affirmative", caption: $L("Add Printer"), onclick: "addPrinterClick", disabled: true}, // enable only if newPrinterID is a valid IP address
						{kind: "Control", className: "network", components: [
						{content: $L("Select a Network"), className: "enyo-text-subheader", style: "padding:0 0 4px"},
						{kind: "RowGroup", components: [{kind: "Item", layoutKind: "HFlexLayout", name: "ssidPickerLayout", showing: true, className: "AddPrinterSsidPickerItem enyo-item enyo-single", tapHighlight: false, components: [
							{kind: "ListSelector", name: "ssidPicker", value: " ", flex: 1, onChange: "ssidPickerChanged", items: [" "]}
						]}]},
						]},
						{kind: "RowGroup", caption: $L("Manually Added"), name: "addedPrinterList", className: "list", components: []},
						{kind: "RowGroup", caption: $L("Auto Discovered"), name: "autoDiscoveredList", className: "list", components: []},
					]}
				]}
			]}
		]},
		{className:"footer-shadow" , name:"footerShadow", showing: false},
		{kind: "Toolbar", className: "enyo-toolbar-light", name: "addPrinterTbar", showing: false, components: [
			{kind: "Button", className: "enyo-button-dark", width:"18.75em", name: "donePrinterButton", caption: $L("Back"), onclick: "donePrinterClick"}
		]},
		{kind: "Scrim", name: "spinnerScrim", layoutKind: "VFlexLayout", align: "center", pack: "center", components: [
			{kind: "SpinnerLarge", showing: true},
		]},
		{kind: "MessageBox", name:"messageBox"},
		{kind: "Popup", name: "removeConfirmPopup", scrim: true, modal: true, width: "351px", height: "auto", components: [
			{kind: "VFlexBox", pack: "justify", align: "center", components: [
				{name: "removeConfirmMessage", content: $L("Printer removed."), className: "message"},
				{kind: "Button", caption: $L("Close"), onclick: "removeConfirmOKClick"}
			]}
		]},
		{kind: "AppMenu", name: "appMenu", components: [
			{caption: $L("Help"), onclick: "appMenuHelpClicked"}
		]}
	],
	create: function() {
		this.inherited(arguments);
		this.$.getRenderStatus.call();
		this.$.getStatus.call();
		this.$.findPrinters.call();
	},
	renderStatusSuccess: function(inSender, inResponse, inRequest) {
		console.log("PrintQueue renderStatusSuccess: inResponse = " + JSON.stringify(inResponse));
		var res = inResponse;
		console.log("PrintQueue renderStatusSuccess: res = " + JSON.stringify(res));
		if (typeof res.jobID !== "undefined") {
			this.updateStatusRender(res);
		}
	},
	jobStatusSuccess: function(inSender, inResponse, inRequest) {
		console.log("PrintQueue jobStatusSuccess: inResponse = " + JSON.stringify(inResponse));
		var res = inResponse;
		console.log("PrintQueue jobStatusSuccess: results = " + JSON.stringify(res));
		if (typeof res.jobID !== "undefined") {
			this.updateStatus(res);
		}
	},
	printManagerFailure: function(inSender, inResponse) {
		console.log("PrintQueue printManagerFailure: " + JSON.stringify(inResponse));
		console.log(inSender.getName() + " FAIL: " + inResponse.errorText);
	},
	updateStatusRender: function(result) {
		var jobID = result.jobID;
		console.log("PrintQueue updateStatusRender: updating job status for jobID = " + jobID);
		var jobStatusItem = this.findJobInQueue(jobID);

		var currPage = -1;
		var totalPgs = -1;
		if (typeof result.currentPage !== "undefined") {
			console.log("PrintQueue updateStatusRender: currentPage = " + result.currentPage);
			currPage = result.currentPage;
		}
		if (typeof result.totalPages !== "undefined") {
			console.log("PrintQueue updateStatusRender: totalPages = " + result.totalPages);
			totalPgs = result.totalPages;
		}

		var status = "Preparing";
		if (currPage !== -1 && totalPgs !== -1 && currPage === totalPgs) { // found last page - done rendering
			status = "PreparingDone";
		}
		else if (currPage === -1 && totalPgs === -1) {		// assume we're done if we get some sort of render
			status = "PreparingDone";			// update that isn't sending page info
		}

		if (typeof jobStatusItem === "undefined") {	// haven't seen this job before - add new job to queue
			var comp = this.$.jobList.createComponent({kind: "JobStatus",
			                                           jobID: jobID,
			                                           printerName: "",
			                                           description: "",
			                                           currentStatus: "Preparing",
			                                           pageNumber: -1,
			                                           totalPages: -1,
			                                           blockedReasons: [],
			                                           onCancellableChange: "jobStatusCancellableChange"
			                                          });
			comp.setOwner(this);
			this.$.jobList.render();
			this.jobStatusCancellableChange();
		}
		else {				// saw this job already - just update its status information
			jobStatusItem.changeRenderStatus(status);
		}
	},
	updateStatus: function(result) {
		var jobID = result.jobID;
		console.log("PrintQueue updateStatus: updating job status for jobID = " + jobID);
		var jobStatusItem = this.findJobInQueue(jobID);
		if (typeof jobStatusItem === "undefined") {	// haven't seen this job before - add new job to queue
			this.addNewJobToQueue(result);
		}
		else {				// saw this job already - just update its status information
			this.updateExistingJobInQueue(jobStatusItem, result);
		}
	},
	findJobInQueue: function(jobID) {
		console.log("PrintQueue findJobInQueue: looking for job with jobID = " + jobID);
		var scrollerItems = this.getComponents();
		var queueItems = this.findJobStatusItems(scrollerItems);
		for (var i = 0; i < queueItems.length; i++) {
			if (queueItems[i].getJobID() === jobID) {
				console.log("PrintQueue findJobInQueue: found job at position " + i);
				return queueItems[i];
			}
		}
		console.log("PrintQueue findJobInQueue: job not found");
		return undefined;
	},
	findJobStatusItems: function(scrollerItems) {
		var returnList = [];
		var returnCount = 0;
		for (var i = 0; i < scrollerItems.length; i++) {
			if (scrollerItems[i].kind === "JobStatus") {
				returnList[returnCount] = scrollerItems[i];
				returnCount++;
			}
		}
		return returnList;
	},
	addNewJobToQueue: function(result) {
		var jobID = result.jobID;
		console.log("PrintQueue addNewJobToQueue: new job found with jobID = " + jobID);

		console.log("PrintQueue addNewJobToQueue: printerID = " + result.printerID);
		console.log("PrintQueue addNewJobToQueue: appName = " + result.appName);
		console.log("PrintQueue addNewJobToQueue: description = " + result.appName);

		var currStatus = "";
		var currPage = -1;
		var totalPgs = -1;
		var blockedReasons = [];
		if (result.statusId === "JOBSTATE") {
			console.log("PrintQueue addNewJobToQueue: printerState = " + result.printerState);
			if (result.printerState === "DONE") {
				if (typeof result.jobStatus !== "undefined") {
					if (result.jobStatus === "Success") {
						currStatus = "Complete";
					}
					else if (result.jobStatus === "Cancelled") {
						currStatus = "Canceled";
					}
					else if (result.jobStatus === "Error" || result.jobStatus === "Corrupt") {
						currStatus = "Failed";
					}
					else {
						currStatus = result.printerState;
					}
				}
				else {
					currStatus = result.printerState;
				}
			}
			else {
				currStatus = result.printerState;
			}
		}

		if (typeof result.currentPage !== "undefined") {
			console.log("PrintQueue addNewJobToQueue: currentPage = " + result.currentPage);
			currPage = result.currentPage;
		}
		if (typeof result.totalPages !== "undefined") {
			console.log("PrintQueue addNewJobToQueue: totalPages = " + result.totalPages);
			totalPgs = result.totalPages;
		}

		if (typeof result.blockedReasons !== "undefined") {
			blockedReasons = result.blockedReasons;
		}
		console.log("PrintQueue addNewJobToQueue: blockedReasons = " + JSON.stringify(blockedReasons));

		this.clearEmptyQueueMessage();
		var comp = this.$.jobList.createComponent({kind: "JobStatus",
		                                           jobID: jobID,
		                                           printerName: result.printerID,
		                                           description: result.appName,
		                                           currentStatus: currStatus,
		                                           pageNumber: currPage,
		                                           totalPages: totalPgs,
		                                           blockedReasons: blockedReasons,
		                                           onCancellableChange: "jobStatusCancellableChange"
		                                          });
		comp.setOwner(this);
		this.$.jobList.render();
		this.jobStatusCancellableChange();

		if (result.statusId === "JOBSTATE" && result.printerState === "DONE" && result.jobStatus === "Success") {
			var jobStatusItem = this.findJobInQueue(jobID);
			if (typeof jobStatusItem !== "undefined") {	// component found successfully
				setTimeout(enyo.bind(this, "destroyJobItem", jobStatusItem), 3000);
			}
		}
	},
	updateExistingJobInQueue: function(jobStatusItem, result) {
		var jobID = result.jobID;
		console.log("PrintQueue updateExistingJobInQueue: existing job found with jobID = " + jobID);

		if (typeof jobStatusItem  === "undefined") {
			console.log("PrintQueue updateExistingJobInQueue: jobStatusItem is undefined");
		}

		console.log("PrintQueue updateExistingJobInQueue: printerID = " + result.printerID);
		jobStatusItem.setPrinterName(result.printerID);
		console.log("PrintQueue updateExistingJobInQueue: description = " + result.appName);
		jobStatusItem.setDescription(result.appName);

		if (typeof result.blockedReasons !== "undefined") {     // send blocked reasons before state so blocked
		                                                        // reasons are available when state set to blocked
			console.log("PrintQueue updateExistingJobInQueue: blockedReasons = " + JSON.stringify(result.blockedReasons));
			jobStatusItem.setBlockedReasons(result.blockedReasons);
		}

		if (result.statusId === "JOBSTATE") {
			console.log("PrintQueue updateExistingJobInQueue: printerState = " + result.printerState);
			if (result.printerState === "DONE") {
				if (typeof result.jobStatus !== "undefined") {
					if (result.jobStatus === "Success") {
						jobStatusItem.setCurrentStatus("Complete");
					}
					else if (result.jobStatus === "Cancelled") {
						jobStatusItem.setCurrentStatus("Canceled");
					}
					else if (result.jobStatus === "Error" || result.jobStatus === "Corrupt") {
						jobStatusItem.setCurrentStatus("Failed");
					}
					else {
						jobStatusItem.setCurrentStatus(result.printerState);
					}
				}
				else {
					jobStatusItem.setCurrentStatus(result.printerState);
				}
			}
			else if (result.printerState === "QUEUED") {
				jobStatusItem.changeRenderStatus("QUEUED");
			}
			else {
				jobStatusItem.setCurrentStatus(result.printerState);
			}
		}

		if (typeof result.currentPage !== "undefined") {
			console.log("PrintQueue updateExistingJobInQueue: currentPage = " + result.currentPage);
			jobStatusItem.setPageNumber(result.currentPage);
		}
		if (typeof result.totalPages !== "undefined") {
			console.log("PrintQueue updateExistingJobInQueue: totalPages = " + result.totalPages);
			jobStatusItem.setTotalPages(result.totalPages);
		}

		if (result.statusId === "JOBSTATE" && result.printerState === "DONE" && result.jobStatus === "Success") {
			setTimeout(enyo.bind(this, "destroyJobItem", jobStatusItem), 3000);
		}
	},
	destroyJobItem: function(jobStatusItem) {
		var jobID = jobStatusItem.getJobID();
		console.log("PrintQueue destroyJobItem: jobID = " + jobID);
		jobStatusItem.destroy();
		if (this.jobItemRemains(jobID) === false) {
			var compItem = this.$.jobList.createComponent({kind: "Item",
			                                               name: "jobListErrorMessageItem",
			                                               className: "JobStatusItem enyo-item"});
			compItem.setOwner(this);
			var compMessage = this.$.jobListErrorMessageItem.createComponent({content: $L("Currently there are no jobs in the printing queue."),
			                                                                  name: "jobListErrorMessage",
			                                                                  className: "message"});
			compMessage.setOwner(this);
		}
		this.$.jobList.render();
	},
	jobItemRemains: function(removedJobID) {
		console.log("PrintQueue jobItemRemains");
		var jobListComponents = this.getComponents();
		var nextComponent;
		for (var i = jobListComponents.length - 1; i >= 0; i--) {
			nextComponent = jobListComponents[i];
			if (nextComponent.kind === "JobStatus") {
				console.log("PrintQueue jobItemRemains: nextComponent jobID = " + nextComponent.getJobID());
				if (nextComponent.getJobID() !== removedJobID) {
					console.log("PrintQueue jobItemRemains: found remaining job, ID = " + nextComponent.getJobID());
					return true;
				}
			}
		}
		console.log("PrintQueue jobItemRemains: no remaining jobs found");
		return false;
	},
	addRemovePrinterClick: function() {
		this.$.addRemovePrinterButton.setDisabled(true);
		this.$.ssidPicker.setValue(" ");
		this.$.ssidPicker.setItems([" "]);
		this.$.bodyPane.selectViewByName("printerPane");
		this.$.footerShadow.show();
		this.$.addPrinterTbar.show();
		this.$.connectionStatus.call();
		this.refreshAutoPrintersList();
	},
	connectionStatusSuccess: function(inSender, inResponse, inRequest) {
		console.log("PrintQueue connectionStatusSuccess: inResponse = " + JSON.stringify(inResponse));

		if (typeof inResponse.wifi !== "undefined" && typeof inResponse.wifi.state !== "undefined" &&
		    inResponse.wifi.state === "connected" && typeof inResponse.wifi.ssid !== "undefined") {
			this.currentWifiSsid = inResponse.wifi.ssid;
		}
		else {
			this.currentWifiSsid = "";
		}

		console.log("PrintQueue connectionStatusSuccess: currentWifiSsid = " + this.currentWifiSsid);
		this.refreshAddedPrintersList();
	},
	connectionStatusFailure: function(inSender, inResponse) {
		console.log("PrintQueue connectionStatusFailure: " + JSON.stringify(inResponse));
		if (typeof inResonse !== "undefined" && typeof inResponse.errorText !== "undefined") {
			console.log(inSender.getName() + " FAIL: " + inResponse.errorText);
		}

		this.clearAddedPrintersList();
		this.displayAddedPrinterError($L("Error getting added printers."));
		this.$.addedPrinterList.render();
		this.$.ssidPickerLayout.setShowing(false);
	},
	addPrinterClick: function() {
		var addPrinterID = this.$.newPrinterID.getValue();
		var addPrinterName = this.$.newPrinterName.getValue();
		this.$.spinnerScrim.show();
		this.$.donePrinterButton.setDisabled(true);
		this.$.addPrinter.call({printerID: addPrinterID, printerName: addPrinterName, printerAddress: addPrinterID});
	},
	donePrinterClick: function() {
		this.$.bodyPane.selectViewByName("queuePane");
		this.$.newPrinterID.setValue("");
		this.$.newPrinterName.setValue("");
		this.$.addPrinterButton.setDisabled(true);
		this.$.addRemovePrinterButton.setDisabled(false);
		this.$.footerShadow.hide();
		this.$.addPrinterTbar.hide();
	},
	addPrinterSuccess: function(inSender, inResponse, inRequest) {
		console.log("PrintQueue addPrinterSuccess: " + JSON.stringify(inResponse));
		this.$.newPrinterID.setValue("");
		this.$.newPrinterName.setValue("");
		this.$.addPrinterButton.setDisabled(true);
		this.refreshAddedPrintersList();
		this.$.spinnerScrim.hide();
		this.$.donePrinterButton.setDisabled(false);
	},
	addPrinterFailure: function(inSender, inResponse, inRequest) {
		console.log("PrintQueue addPrinterFailure: " + JSON.stringify(inResponse));
		console.log(inSender.getName() + " FAIL: " + inResponse.errorText);
		this.$.spinnerScrim.hide();
		this.$.messageBox.showMessage(PrintManagerError.getErrorText(inResponse.errorCode));
		this.$.donePrinterButton.setDisabled(false);
	},
	refreshAddedPrintersList: function() {
		this.$.listAddedPrinters.call({ssidAll: true});
	},
	clearAddedPrintersList: function() {
		var addedPrinterComponents = this.getComponents();
		var nextComponent;
		for (var i = addedPrinterComponents.length - 1; i >= 0; i--) {
			nextComponent = addedPrinterComponents[i];
			if (nextComponent.kind === "AddedPrinter" || nextComponent.name === "addedPrinterListErrorMessageItem") {
				console.log("PrintQueue clearAddedPrintersList: destroying component");
				nextComponent.destroy();
			}
		}
	},
	listAddedPrintersSuccess: function(inSender, inResponse, inRequest) {
		console.log("PrintQueue listAddedPrintersSuccess: " + JSON.stringify(inResponse));
		this.clearAddedPrintersList();
		var addedPrinters = inResponse.addList;
		if (typeof addedPrinters === "undefined") {
			return;
		}
		var nextAddedPrinter;
		var nextAddedPrinterSsid;
		this.ssidList = [];
		this.addedPrinterList = [];

		for (var i = 0; i < addedPrinters.length; i++) {
			nextAddedPrinter = addedPrinters[i];
			nextAddedPrinterSsid = nextAddedPrinter.ssid;

			if (nextAddedPrinterSsid !== this.currentWifiSsid && this.ssidList.indexOf(nextAddedPrinterSsid) === -1) {
				// haven't seen this ssid yet
				var ssidListLength = this.ssidList.length;
				this.ssidList[ssidListLength] = nextAddedPrinterSsid;
			}
		}
		this.ssidList.sort();

		if (this.currentWifiSsid !== "") {
			this.ssidList.splice(0, 0, this.currentWifiSsid);
		}

		if (this.ssidList.length > 0) {
			this.$.ssidPicker.setItems(this.ssidList);
			this.$.ssidPicker.setValue(this.ssidList[0]);
		}

		var comp;
		var addedPrinterCount = 0;
		for (i = 0; i < addedPrinters.length; i++) {
			nextAddedPrinter = addedPrinters[i];
			console.log("PrintQueue listAddedPrintersSuccess: nextAddedPrinter = " + JSON.stringify(nextAddedPrinter));

			this.addedPrinterList[i] = {printerID: nextAddedPrinter.printerID,
			                            printerName: nextAddedPrinter.printerName,
			                            printerAddress: nextAddedPrinter.printerAddress,
			                            printerSSID: nextAddedPrinter.ssid
				};

			if (nextAddedPrinter.ssid === this.ssidList[0]) {
				comp = this.$.addedPrinterList.createComponent({kind: "AddedPrinter",
				                                                printerID: nextAddedPrinter.printerID,
				                                                printerName: nextAddedPrinter.printerName,
				                                                printerAddress: nextAddedPrinter.printerAddress,
				                                                printerSSID: nextAddedPrinter.ssid,
				                                                onRemove: "addedPrinterRemove"
					});
				comp.setOwner(this);
				this.$.addedPrinterList.render();
				addedPrinterCount++;
			}
		}
		if (this.ssidList.length > 0) {
			this.$.ssidPickerLayout.setShowing(true);
		}
		else {
			this.$.ssidPickerLayout.setShowing(false);
		}

		console.log("PrintQueue listAddedPrintersSuccess: addedPrinterCount = " + addedPrinterCount);
		if (addedPrinterCount === 0) {
			console.log("PrintQueue listAddedPrintersSuccess: Adding empty list message");
			this.displayAddedPrinterError($L("You currently have no added printers."));
			this.$.addedPrinterList.render();
		}
	},
	listAddedPrintersFailure: function(inSender, inResponse, inRequest) {
		console.log("PrintQueue listAddedPrintersFailure: " + JSON.stringify(inResponse));
		if (typeof inResonse !== "undefined" && typeof inResponse.errorText !== "undefined") {
			console.log(inSender.getName() + " FAIL: " + inResponse.errorText);
		}

		this.clearAddedPrintersList();
		this.displayAddedPrinterError($L("Error getting added printers."));
		this.$.addedPrinterList.render();
		this.$.ssidPickerLayout.setShowing(false);
	},
	ssidPickerChanged: function(inSender, inValue, inOldValue) {
		console.log("PrintQueue ssidPickerChanged: inValue = " + inValue);
		this.clearAddedPrintersList();
		var nextAddedPrinter;
		var addedPrinterCount = 0;
		for (var i = 0; i < this.addedPrinterList.length; i++) {
			nextAddedPrinter = this.addedPrinterList[i];
			console.log("PrintQueue ssidPickerChanged: nextAddedPrinter = " + JSON.stringify(nextAddedPrinter));

			if (this.addedPrinterList[i].printerSSID === inValue) {
				comp = this.$.addedPrinterList.createComponent({kind: "AddedPrinter",
				                                                printerID: nextAddedPrinter.printerID,
				                                                printerName: nextAddedPrinter.printerName,
				                                                printerAddress: nextAddedPrinter.printerAddress,
				                                                printerSSID: nextAddedPrinter.printerSSID,
				                                                onRemove: "addedPrinterRemove"
					});
				comp.setOwner(this);
				this.$.addedPrinterList.render();
				addedPrinterCount++;
			}
		}

		console.log("PrintQueue ssidPickerChanged: addedPrinterCount = " + addedPrinterCount);
		if (addedPrinterCount === 0) {
			console.log("PrintQueue ssidPickerChanged: Adding empty list message");
			this.displayAddedPrinterError( $L("You currently have no added printers."));
			this.$.addedPrinterList.render();
		}
	},
	addedPrinterRemove: function(inSender, printerID, printerName, printerAddress, printerSSID) {
		this.removeComponentData = {printerID: printerID,
		                            printerName: printerName,
		                            printerAddress: printerAddress,
		                            printerSSID: printerSSID
			};
		console.log("PrintQueue addedPrinterRemove: removeComponentData = " + JSON.stringify(this.removeComponentData));

		var addedPrinterComponents = this.getComponents();
		var nextComponent;
		var nextComponentData;
		var remainingPrinterCount = 0;
		for (var i = addedPrinterComponents.length - 1; i >= 0; i--) {		// find printer in viewable list and remove it
			nextComponent = addedPrinterComponents[i];

			if (nextComponent.kind === "AddedPrinter") {
				nextComponentData = {printerID: nextComponent.getPrinterID(),
				                     printerName: nextComponent.getPrinterName(),
				                     printerAddress: nextComponent.getPrinterAddress(),
				                     printerSSID: nextComponent.getPrinterSSID()
					};
				console.log("PrintQueue addedPrinterRemove: nextComponentData = " + JSON.stringify(nextComponentData));

				if (nextComponent.getPrinterID() === printerID &&
				    nextComponent.getPrinterName() === printerName &&
				    nextComponent.getPrinterAddress() === printerAddress &
				    nextComponent.getPrinterSSID() === printerSSID) {
					console.log("PrintQueue addedPrinterRemove: destroying component for removed printer");
					nextComponent.destroy();
				}
				else {
					remainingPrinterCount++;
				}
			}
		}

		console.log("PrintQueue addedPrinterRemove: remainingPrinterCount = " + remainingPrinterCount);
		if (remainingPrinterCount === 0) {
			console.log("PrintQueue addedPrinterRemove: Adding empty list message");
			this.displayAddedPrinterError($L("You currently have no added printers."));
			this.$.addedPrinterList.render();
		}

		var nextAddedPrinter;
		for (var i = (this.addedPrinterList.length - 1); i >= 0; i--) {		// find printer in internal cached list and remove it
			nextAddedPrinter = this.addedPrinterList[i];
			nextAddedPrinterData = {printerID: nextAddedPrinter.printerID,
			                        printerName: nextAddedPrinter.printerName,
			                        printerAddress: nextAddedPrinter.printerAddress,
			                        printerSSID: nextAddedPrinter.printerSSID
				};
			console.log("PrintQueue addedPrinterRemove: nextAddedPrinterData = " + JSON.stringify(nextAddedPrinterData));

			if (nextAddedPrinter.printerID === printerID &&
			    nextAddedPrinter.printerName === printerName &&
			    nextAddedPrinter.printerAddress === printerAddress &&
			    nextAddedPrinter.printerSSID === printerSSID) {
				console.log("PrintQueue addedPrinterRemove: removing item from addedPrinterList");
				this.addedPrinterList.splice(i, 1);
			}
		}

		this.$.removeConfirmPopup.openAtCenter();
	},
	displayAddedPrinterError: function(message) {
		var compItem = this.$.addedPrinterList.createComponent({kind: "Item",
		                                                        name: "addedPrinterListErrorMessageItem",
		                                                        className: "AddedPrinterItem enyo-item"});
		compItem.setOwner(this);
		var compMessage = this.$.addedPrinterListErrorMessageItem.createComponent({content: message,
		                                                                           name: "addedPrinterListErrorMessage",
			                                                                   className: "AddedPrinterInfo"});
		compMessage.setOwner(this);
	},
	cancelAllClick: function() {
		console.log("PrintQueue cancelAllClick");
		var scrollerItems = this.getComponents();
		var queueItems = this.findJobStatusItems(scrollerItems);
		for (var i = 0; i < queueItems.length; i++) {
			queueItems[i].cancelJobFromQueue();
		}
	},
	removeConfirmOKClick: function() {
		this.$.removeConfirmPopup.close();
	},
	clearEmptyQueueMessage: function() {
		var jobListComponents = this.getComponents();
		var nextComponent;
		for (var i = jobListComponents.length - 1; i >= 0; i--) {
			nextComponent = jobListComponents[i];
			if (nextComponent.name === "jobListErrorMessageItem") {
				console.log("PrintQueue clearEmptyQueueMessage: destroying component");
				nextComponent.destroy();
			}
		}
	},
	printerIDInput: function(inSender, inEvent, inValue) {
		console.log("PrintQueue printerIDInput: inValue = " + inValue);
		if (inValue.length === 0) {		// disable button when no ip address has been typed
			this.$.addPrinterButton.setDisabled(true);
		}
		else {
			this.$.addPrinterButton.setDisabled(false);
		}
	},
	jobStatusCancellableChange: function() {
		console.log("PrintQueue jobStatusCancellableChange");
		var scrollerItems = this.getComponents();
		var queueItems = this.findJobStatusItems(scrollerItems);
		var nextQueueItem;
		var cancellableJob = false;
		for (var i = 0; (cancellableJob === false) && (i < queueItems.length); i++) {
			nextQueueItem = queueItems[i];
			if (nextQueueItem.isCancellable()) {
				cancellableJob = true;
			}
		}

		if (cancellableJob === true) {
			this.$.cancelAllButton.setDisabled(false);
		}
		else {
			this.$.cancelAllButton.setDisabled(true);
		}
	},
	findPrintersSuccess: function(inSender, inResponse, inRequest) {
		console.log("PrintQueue findPrintersSuccess: " + JSON.stringify(inResponse));

		if (typeof inResponse.source !== "undefined" && inResponse.source === "fromManualAdd") {
			// skip manually added printers as this is being used to populate auto discovered printer list
			console.log("PrintQueue findPrintersSuccess: manually added printer detected");
			return;
		}

		if (typeof inResponse.eventType !== "undefined" && typeof inResponse.printerID !== "undefined" &&
		    typeof inResponse.printerName !== "undefined" && typeof inResponse.printerAddress !== "undefined") {
			if (inResponse.eventType === "Add") {
				this.addAutoPrinter(inResponse.printerID, inResponse.printerName, inResponse.printerAddress);
			}
			else if (inResponse.eventType === "Rmv") {
				this.removeAutoPrinter(inResponse.printerID, inResponse.printerName, inResponse.printerAddress);
			}

			if (this.$.printerPane.getShowing() === true) {
				this.refreshAutoPrintersList();
			}
		}
	},
	addAutoPrinter: function(printerID, printerName, printerAddress) {
		console.log("PrintQueue addAutoPrinter: printerID = " + printerID + ", printerName = " + printerName + ", printerAddress = " + printerAddress);
		var nextAutoPrinter;
		for (var i = 0; i < this.autoPrinters.length; i++) {
			nextAutoPrinter = this.autoPrinters[i];
			if (nextAutoPrinter.printerID === printerID) {
				console.log("PrintQueue addAutoPrinter: auto printer already exists in list");
				this.autoPrinters[i].printerName = printerName;
				return;
			}
		}

		var autoPrintersLength = this.autoPrinters.length;
		var newAutoPrinter = {printerID: printerID, printerName: printerName, printerAddress: printerAddress};
		console.log("PrintQueue addAutoPrinter: newAutoPrinter = " + JSON.stringify(newAutoPrinter));
		this.autoPrinters[autoPrintersLength] = newAutoPrinter;
	},
	removeAutoPrinter: function(printerID, printerName, printerAddress) {
		console.log("PrintQueue removeAutoPrinter: printerID = " + printerID + ", printerName = " + printerName + ", printerAddress = " + printerAddress);
		var nextAutoPrinter;
		for (var i = 0; i < this.autoPrinters.length; i++) {
			nextAutoPrinter = this.autoPrinters[i];
			if (nextAutoPrinter.printerID === printerID) {
				console.log("PrintQueue removeAutoPrinter: printer found for removal");
				this.autoPrinters.splice(i, 1);
				return;
			}
		}

		console.log("PrintQueue removeAutoPrinter: printer not found in list");
	},
	refreshAutoPrintersList: function() {
		console.log("PrintQueue refreshAutoPrintersList");
		this.clearAutoPrintersList();

		var comp;
		var addedPrinterCount = 0;
		for (var i = 0; i < this.autoPrinters.length; i++) {
			nextAutoPrinter = this.autoPrinters[i];
			console.log("PrintQueue refreshAutoPrintersList: nextAutoPrinter = " + JSON.stringify(nextAutoPrinter));

			comp = this.$.autoDiscoveredList.createComponent({kind: "AutoPrinter",
			                                                  printerID: nextAutoPrinter.printerID,
			                                                  printerName: nextAutoPrinter.printerName,
			                                                  printerAddress: nextAutoPrinter.printerAddress
				});
			comp.setOwner(this);
			this.$.autoDiscoveredList.render();
			addedPrinterCount++;
		}

		console.log("PrintQueue refreshAutoPrintersList: addedPrinterCount = " + addedPrinterCount);
		if (addedPrinterCount === 0) {
			console.log("PrintQueue refreshAutoPrintersList: Adding empty list message");
			this.displayAutoPrinterError($L("You currently have no automatically detected printers."));
			this.$.autoDiscoveredList.render();
		}

	},
	clearAutoPrintersList: function() {
		var queueComponents = this.getComponents();
		var nextComponent;
		for (var i = queueComponents.length - 1; i >= 0; i--) {
			nextComponent = queueComponents[i];
			if (nextComponent.kind === "AutoPrinter" || nextComponent.name === "autoDiscoveredListErrorMessageItem") {
				console.log("PrintQueue clearAutoPrintersList: destroying component");
				nextComponent.destroy();
			}
		}
	},
	displayAutoPrinterError: function(message) {
		var compItem = this.$.autoDiscoveredList.createComponent({kind: "Item",
		                                                          name: "autoDiscoveredListErrorMessageItem",
		                                                          className: "message"});
		compItem.setOwner(this);
		var compMessage = this.$.autoDiscoveredListErrorMessageItem.createComponent({content: message,
		                                                                             name: "autoDiscoveredListErrorMessage",
			                                                                     className: "AddedPrinterInfo"});
		compMessage.setOwner(this);
	},
	appMenuHelpClicked: function() {
		var url = "http://help.palm.com/print_manager/index.json";
		this.$.helpLauncher.call({id: "com.palm.app.help", params: {target: url}});
	}
});